from datetime import date, datetime  # noqa: F401
from typing import Dict, List  # noqa: F401

from timestep.api.openai.v1 import util
from timestep.api.openai.v1.models.assistant_tools_code import \
    AssistantToolsCode  # noqa: E501
from timestep.api.openai.v1.models.assistant_tools_file_search import \
    AssistantToolsFileSearch  # noqa: E501
from timestep.api.openai.v1.models.assistant_tools_file_search_file_search import \
    AssistantToolsFileSearchFileSearch  # noqa: E501
from timestep.api.openai.v1.models.assistant_tools_function import \
    AssistantToolsFunction  # noqa: E501
from timestep.api.openai.v1.models.base_model import Model
from timestep.api.openai.v1.models.function_object import \
    FunctionObject  # noqa: E501


class AssistantObjectToolsInner(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, type=None, file_search=None, function=None):  # noqa: E501
        """AssistantObjectToolsInner - a model defined in OpenAPI

        :param type: The type of this AssistantObjectToolsInner.  # noqa: E501
        :type type: str
        :param file_search: The file_search of this AssistantObjectToolsInner.  # noqa: E501
        :type file_search: AssistantToolsFileSearchFileSearch
        :param function: The function of this AssistantObjectToolsInner.  # noqa: E501
        :type function: FunctionObject
        """
        self.openapi_types = {
            'type': str,
            'file_search': AssistantToolsFileSearchFileSearch,
            'function': FunctionObject
        }

        self.attribute_map = {
            'type': 'type',
            'file_search': 'file_search',
            'function': 'function'
        }

        self._type = type
        self._file_search = file_search
        self._function = function

    @classmethod
    def from_dict(cls, dikt) -> 'AssistantObjectToolsInner':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The AssistantObject_tools_inner of this AssistantObjectToolsInner.  # noqa: E501
        :rtype: AssistantObjectToolsInner
        """
        return util.deserialize_model(dikt, cls)

    @property
    def type(self) -> str:
        """Gets the type of this AssistantObjectToolsInner.

        The type of tool being defined: `code_interpreter`  # noqa: E501

        :return: The type of this AssistantObjectToolsInner.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type: str):
        """Sets the type of this AssistantObjectToolsInner.

        The type of tool being defined: `code_interpreter`  # noqa: E501

        :param type: The type of this AssistantObjectToolsInner.
        :type type: str
        """
        allowed_values = ["code_interpreter", "file_search", "function"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def file_search(self) -> AssistantToolsFileSearchFileSearch:
        """Gets the file_search of this AssistantObjectToolsInner.


        :return: The file_search of this AssistantObjectToolsInner.
        :rtype: AssistantToolsFileSearchFileSearch
        """
        return self._file_search

    @file_search.setter
    def file_search(self, file_search: AssistantToolsFileSearchFileSearch):
        """Sets the file_search of this AssistantObjectToolsInner.


        :param file_search: The file_search of this AssistantObjectToolsInner.
        :type file_search: AssistantToolsFileSearchFileSearch
        """

        self._file_search = file_search

    @property
    def function(self) -> FunctionObject:
        """Gets the function of this AssistantObjectToolsInner.


        :return: The function of this AssistantObjectToolsInner.
        :rtype: FunctionObject
        """
        return self._function

    @function.setter
    def function(self, function: FunctionObject):
        """Sets the function of this AssistantObjectToolsInner.


        :param function: The function of this AssistantObjectToolsInner.
        :type function: FunctionObject
        """
        if function is None:
            raise ValueError("Invalid value for `function`, must not be `None`")  # noqa: E501

        self._function = function
