from datetime import date, datetime  # noqa: F401
from typing import Dict, List  # noqa: F401

from timestep.api.openai.v1 import util
from timestep.api.openai.v1.models.base_model import Model
from timestep.api.openai.v1.models.function_object import \
    FunctionObject  # noqa: E501


class AssistantToolsFunction(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, type=None, function=None):  # noqa: E501
        """AssistantToolsFunction - a model defined in OpenAPI

        :param type: The type of this AssistantToolsFunction.  # noqa: E501
        :type type: str
        :param function: The function of this AssistantToolsFunction.  # noqa: E501
        :type function: FunctionObject
        """
        self.openapi_types = {
            'type': str,
            'function': FunctionObject
        }

        self.attribute_map = {
            'type': 'type',
            'function': 'function'
        }

        self._type = type
        self._function = function

    @classmethod
    def from_dict(cls, dikt) -> 'AssistantToolsFunction':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The AssistantToolsFunction of this AssistantToolsFunction.  # noqa: E501
        :rtype: AssistantToolsFunction
        """
        return util.deserialize_model(dikt, cls)

    @property
    def type(self) -> str:
        """Gets the type of this AssistantToolsFunction.

        The type of tool being defined: `function`  # noqa: E501

        :return: The type of this AssistantToolsFunction.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type: str):
        """Sets the type of this AssistantToolsFunction.

        The type of tool being defined: `function`  # noqa: E501

        :param type: The type of this AssistantToolsFunction.
        :type type: str
        """
        allowed_values = ["function"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def function(self) -> FunctionObject:
        """Gets the function of this AssistantToolsFunction.


        :return: The function of this AssistantToolsFunction.
        :rtype: FunctionObject
        """
        return self._function

    @function.setter
    def function(self, function: FunctionObject):
        """Sets the function of this AssistantToolsFunction.


        :param function: The function of this AssistantToolsFunction.
        :type function: FunctionObject
        """
        if function is None:
            raise ValueError("Invalid value for `function`, must not be `None`")  # noqa: E501

        self._function = function
