from datetime import date, datetime  # noqa: F401
from typing import Dict, List  # noqa: F401

from timestep.api.openai.v1 import util
from timestep.api.openai.v1.models.base_model import Model


class BatchRequestOutputResponse(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, status_code=None, request_id=None, body=None):  # noqa: E501
        """BatchRequestOutputResponse - a model defined in OpenAPI

        :param status_code: The status_code of this BatchRequestOutputResponse.  # noqa: E501
        :type status_code: int
        :param request_id: The request_id of this BatchRequestOutputResponse.  # noqa: E501
        :type request_id: str
        :param body: The body of this BatchRequestOutputResponse.  # noqa: E501
        :type body: object
        """
        self.openapi_types = {
            'status_code': int,
            'request_id': str,
            'body': object
        }

        self.attribute_map = {
            'status_code': 'status_code',
            'request_id': 'request_id',
            'body': 'body'
        }

        self._status_code = status_code
        self._request_id = request_id
        self._body = body

    @classmethod
    def from_dict(cls, dikt) -> 'BatchRequestOutputResponse':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The BatchRequestOutput_response of this BatchRequestOutputResponse.  # noqa: E501
        :rtype: BatchRequestOutputResponse
        """
        return util.deserialize_model(dikt, cls)

    @property
    def status_code(self) -> int:
        """Gets the status_code of this BatchRequestOutputResponse.

        The HTTP status code of the response  # noqa: E501

        :return: The status_code of this BatchRequestOutputResponse.
        :rtype: int
        """
        return self._status_code

    @status_code.setter
    def status_code(self, status_code: int):
        """Sets the status_code of this BatchRequestOutputResponse.

        The HTTP status code of the response  # noqa: E501

        :param status_code: The status_code of this BatchRequestOutputResponse.
        :type status_code: int
        """

        self._status_code = status_code

    @property
    def request_id(self) -> str:
        """Gets the request_id of this BatchRequestOutputResponse.

        An unique identifier for the OpenAI API request. Please include this request ID when contacting support.  # noqa: E501

        :return: The request_id of this BatchRequestOutputResponse.
        :rtype: str
        """
        return self._request_id

    @request_id.setter
    def request_id(self, request_id: str):
        """Sets the request_id of this BatchRequestOutputResponse.

        An unique identifier for the OpenAI API request. Please include this request ID when contacting support.  # noqa: E501

        :param request_id: The request_id of this BatchRequestOutputResponse.
        :type request_id: str
        """

        self._request_id = request_id

    @property
    def body(self) -> object:
        """Gets the body of this BatchRequestOutputResponse.

        The JSON body of the response  # noqa: E501

        :return: The body of this BatchRequestOutputResponse.
        :rtype: object
        """
        return self._body

    @body.setter
    def body(self, body: object):
        """Sets the body of this BatchRequestOutputResponse.

        The JSON body of the response  # noqa: E501

        :param body: The body of this BatchRequestOutputResponse.
        :type body: object
        """

        self._body = body
