from datetime import date, datetime  # noqa: F401
from typing import Dict, List  # noqa: F401

from timestep.api.openai.v1 import util
from timestep.api.openai.v1.models.base_model import Model
from timestep.api.openai.v1.models.chat_completion_message_tool_call_function import \
    ChatCompletionMessageToolCallFunction  # noqa: E501


class ChatCompletionMessageToolCall(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id=None, type=None, function=None):  # noqa: E501
        """ChatCompletionMessageToolCall - a model defined in OpenAPI

        :param id: The id of this ChatCompletionMessageToolCall.  # noqa: E501
        :type id: str
        :param type: The type of this ChatCompletionMessageToolCall.  # noqa: E501
        :type type: str
        :param function: The function of this ChatCompletionMessageToolCall.  # noqa: E501
        :type function: ChatCompletionMessageToolCallFunction
        """
        self.openapi_types = {
            'id': str,
            'type': str,
            'function': ChatCompletionMessageToolCallFunction
        }

        self.attribute_map = {
            'id': 'id',
            'type': 'type',
            'function': 'function'
        }

        self._id = id
        self._type = type
        self._function = function

    @classmethod
    def from_dict(cls, dikt) -> 'ChatCompletionMessageToolCall':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The ChatCompletionMessageToolCall of this ChatCompletionMessageToolCall.  # noqa: E501
        :rtype: ChatCompletionMessageToolCall
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self) -> str:
        """Gets the id of this ChatCompletionMessageToolCall.

        The ID of the tool call.  # noqa: E501

        :return: The id of this ChatCompletionMessageToolCall.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id: str):
        """Sets the id of this ChatCompletionMessageToolCall.

        The ID of the tool call.  # noqa: E501

        :param id: The id of this ChatCompletionMessageToolCall.
        :type id: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def type(self) -> str:
        """Gets the type of this ChatCompletionMessageToolCall.

        The type of the tool. Currently, only `function` is supported.  # noqa: E501

        :return: The type of this ChatCompletionMessageToolCall.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type: str):
        """Sets the type of this ChatCompletionMessageToolCall.

        The type of the tool. Currently, only `function` is supported.  # noqa: E501

        :param type: The type of this ChatCompletionMessageToolCall.
        :type type: str
        """
        allowed_values = ["function"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def function(self) -> ChatCompletionMessageToolCallFunction:
        """Gets the function of this ChatCompletionMessageToolCall.


        :return: The function of this ChatCompletionMessageToolCall.
        :rtype: ChatCompletionMessageToolCallFunction
        """
        return self._function

    @function.setter
    def function(self, function: ChatCompletionMessageToolCallFunction):
        """Sets the function of this ChatCompletionMessageToolCall.


        :param function: The function of this ChatCompletionMessageToolCall.
        :type function: ChatCompletionMessageToolCallFunction
        """
        if function is None:
            raise ValueError("Invalid value for `function`, must not be `None`")  # noqa: E501

        self._function = function
