from datetime import date, datetime  # noqa: F401
from typing import Dict, List  # noqa: F401

from timestep.api.openai.v1 import util
from timestep.api.openai.v1.models.base_model import Model


class ChatCompletionRequestFunctionMessage(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, role=None, content=None, name=None):  # noqa: E501
        """ChatCompletionRequestFunctionMessage - a model defined in OpenAPI

        :param role: The role of this ChatCompletionRequestFunctionMessage.  # noqa: E501
        :type role: str
        :param content: The content of this ChatCompletionRequestFunctionMessage.  # noqa: E501
        :type content: str
        :param name: The name of this ChatCompletionRequestFunctionMessage.  # noqa: E501
        :type name: str
        """
        self.openapi_types = {
            'role': str,
            'content': str,
            'name': str
        }

        self.attribute_map = {
            'role': 'role',
            'content': 'content',
            'name': 'name'
        }

        self._role = role
        self._content = content
        self._name = name

    @classmethod
    def from_dict(cls, dikt) -> 'ChatCompletionRequestFunctionMessage':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The ChatCompletionRequestFunctionMessage of this ChatCompletionRequestFunctionMessage.  # noqa: E501
        :rtype: ChatCompletionRequestFunctionMessage
        """
        return util.deserialize_model(dikt, cls)

    @property
    def role(self) -> str:
        """Gets the role of this ChatCompletionRequestFunctionMessage.

        The role of the messages author, in this case `function`.  # noqa: E501

        :return: The role of this ChatCompletionRequestFunctionMessage.
        :rtype: str
        """
        return self._role

    @role.setter
    def role(self, role: str):
        """Sets the role of this ChatCompletionRequestFunctionMessage.

        The role of the messages author, in this case `function`.  # noqa: E501

        :param role: The role of this ChatCompletionRequestFunctionMessage.
        :type role: str
        """
        allowed_values = ["function"]  # noqa: E501
        if role not in allowed_values:
            raise ValueError(
                "Invalid value for `role` ({0}), must be one of {1}"
                .format(role, allowed_values)
            )

        self._role = role

    @property
    def content(self) -> str:
        """Gets the content of this ChatCompletionRequestFunctionMessage.

        The contents of the function message.  # noqa: E501

        :return: The content of this ChatCompletionRequestFunctionMessage.
        :rtype: str
        """
        return self._content

    @content.setter
    def content(self, content: str):
        """Sets the content of this ChatCompletionRequestFunctionMessage.

        The contents of the function message.  # noqa: E501

        :param content: The content of this ChatCompletionRequestFunctionMessage.
        :type content: str
        """
        if content is None:
            raise ValueError("Invalid value for `content`, must not be `None`")  # noqa: E501

        self._content = content

    @property
    def name(self) -> str:
        """Gets the name of this ChatCompletionRequestFunctionMessage.

        The name of the function to call.  # noqa: E501

        :return: The name of this ChatCompletionRequestFunctionMessage.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name: str):
        """Sets the name of this ChatCompletionRequestFunctionMessage.

        The name of the function to call.  # noqa: E501

        :param name: The name of this ChatCompletionRequestFunctionMessage.
        :type name: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name
