from datetime import date, datetime  # noqa: F401
from typing import Dict, List  # noqa: F401

from timestep.api.openai.v1 import util
from timestep.api.openai.v1.models.base_model import Model
from timestep.api.openai.v1.models.chat_completion_request_message_content_part_image import \
    ChatCompletionRequestMessageContentPartImage  # noqa: E501
from timestep.api.openai.v1.models.chat_completion_request_message_content_part_image_image_url import \
    ChatCompletionRequestMessageContentPartImageImageUrl  # noqa: E501
from timestep.api.openai.v1.models.chat_completion_request_message_content_part_text import \
    ChatCompletionRequestMessageContentPartText  # noqa: E501


class ChatCompletionRequestMessageContentPart(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, type=None, text=None, image_url=None):  # noqa: E501
        """ChatCompletionRequestMessageContentPart - a model defined in OpenAPI

        :param type: The type of this ChatCompletionRequestMessageContentPart.  # noqa: E501
        :type type: str
        :param text: The text of this ChatCompletionRequestMessageContentPart.  # noqa: E501
        :type text: str
        :param image_url: The image_url of this ChatCompletionRequestMessageContentPart.  # noqa: E501
        :type image_url: ChatCompletionRequestMessageContentPartImageImageUrl
        """
        self.openapi_types = {
            'type': str,
            'text': str,
            'image_url': ChatCompletionRequestMessageContentPartImageImageUrl
        }

        self.attribute_map = {
            'type': 'type',
            'text': 'text',
            'image_url': 'image_url'
        }

        self._type = type
        self._text = text
        self._image_url = image_url

    @classmethod
    def from_dict(cls, dikt) -> 'ChatCompletionRequestMessageContentPart':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The ChatCompletionRequestMessageContentPart of this ChatCompletionRequestMessageContentPart.  # noqa: E501
        :rtype: ChatCompletionRequestMessageContentPart
        """
        return util.deserialize_model(dikt, cls)

    @property
    def type(self) -> str:
        """Gets the type of this ChatCompletionRequestMessageContentPart.

        The type of the content part.  # noqa: E501

        :return: The type of this ChatCompletionRequestMessageContentPart.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type: str):
        """Sets the type of this ChatCompletionRequestMessageContentPart.

        The type of the content part.  # noqa: E501

        :param type: The type of this ChatCompletionRequestMessageContentPart.
        :type type: str
        """
        allowed_values = ["text", "image_url"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def text(self) -> str:
        """Gets the text of this ChatCompletionRequestMessageContentPart.

        The text content.  # noqa: E501

        :return: The text of this ChatCompletionRequestMessageContentPart.
        :rtype: str
        """
        return self._text

    @text.setter
    def text(self, text: str):
        """Sets the text of this ChatCompletionRequestMessageContentPart.

        The text content.  # noqa: E501

        :param text: The text of this ChatCompletionRequestMessageContentPart.
        :type text: str
        """
        if text is None:
            raise ValueError("Invalid value for `text`, must not be `None`")  # noqa: E501

        self._text = text

    @property
    def image_url(self) -> ChatCompletionRequestMessageContentPartImageImageUrl:
        """Gets the image_url of this ChatCompletionRequestMessageContentPart.


        :return: The image_url of this ChatCompletionRequestMessageContentPart.
        :rtype: ChatCompletionRequestMessageContentPartImageImageUrl
        """
        return self._image_url

    @image_url.setter
    def image_url(self, image_url: ChatCompletionRequestMessageContentPartImageImageUrl):
        """Sets the image_url of this ChatCompletionRequestMessageContentPart.


        :param image_url: The image_url of this ChatCompletionRequestMessageContentPart.
        :type image_url: ChatCompletionRequestMessageContentPartImageImageUrl
        """
        if image_url is None:
            raise ValueError("Invalid value for `image_url`, must not be `None`")  # noqa: E501

        self._image_url = image_url
