from datetime import date, datetime  # noqa: F401
from typing import Dict, List  # noqa: F401

from timestep.api.openai.v1 import util
from timestep.api.openai.v1.models.base_model import Model
from timestep.api.openai.v1.models.chat_completion_request_user_message_content import \
    ChatCompletionRequestUserMessageContent  # noqa: E501


class ChatCompletionRequestUserMessage(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, content=None, role=None, name=None):  # noqa: E501
        """ChatCompletionRequestUserMessage - a model defined in OpenAPI

        :param content: The content of this ChatCompletionRequestUserMessage.  # noqa: E501
        :type content: ChatCompletionRequestUserMessageContent
        :param role: The role of this ChatCompletionRequestUserMessage.  # noqa: E501
        :type role: str
        :param name: The name of this ChatCompletionRequestUserMessage.  # noqa: E501
        :type name: str
        """
        self.openapi_types = {
            'content': ChatCompletionRequestUserMessageContent,
            'role': str,
            'name': str
        }

        self.attribute_map = {
            'content': 'content',
            'role': 'role',
            'name': 'name'
        }

        self._content = content
        self._role = role
        self._name = name

    @classmethod
    def from_dict(cls, dikt) -> 'ChatCompletionRequestUserMessage':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The ChatCompletionRequestUserMessage of this ChatCompletionRequestUserMessage.  # noqa: E501
        :rtype: ChatCompletionRequestUserMessage
        """
        return util.deserialize_model(dikt, cls)

    @property
    def content(self) -> ChatCompletionRequestUserMessageContent:
        """Gets the content of this ChatCompletionRequestUserMessage.


        :return: The content of this ChatCompletionRequestUserMessage.
        :rtype: ChatCompletionRequestUserMessageContent
        """
        return self._content

    @content.setter
    def content(self, content: ChatCompletionRequestUserMessageContent):
        """Sets the content of this ChatCompletionRequestUserMessage.


        :param content: The content of this ChatCompletionRequestUserMessage.
        :type content: ChatCompletionRequestUserMessageContent
        """
        if content is None:
            raise ValueError("Invalid value for `content`, must not be `None`")  # noqa: E501

        self._content = content

    @property
    def role(self) -> str:
        """Gets the role of this ChatCompletionRequestUserMessage.

        The role of the messages author, in this case `user`.  # noqa: E501

        :return: The role of this ChatCompletionRequestUserMessage.
        :rtype: str
        """
        return self._role

    @role.setter
    def role(self, role: str):
        """Sets the role of this ChatCompletionRequestUserMessage.

        The role of the messages author, in this case `user`.  # noqa: E501

        :param role: The role of this ChatCompletionRequestUserMessage.
        :type role: str
        """
        allowed_values = ["user"]  # noqa: E501
        if role not in allowed_values:
            raise ValueError(
                "Invalid value for `role` ({0}), must be one of {1}"
                .format(role, allowed_values)
            )

        self._role = role

    @property
    def name(self) -> str:
        """Gets the name of this ChatCompletionRequestUserMessage.

        An optional name for the participant. Provides the model information to differentiate between participants of the same role.  # noqa: E501

        :return: The name of this ChatCompletionRequestUserMessage.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name: str):
        """Sets the name of this ChatCompletionRequestUserMessage.

        An optional name for the participant. Provides the model information to differentiate between participants of the same role.  # noqa: E501

        :param name: The name of this ChatCompletionRequestUserMessage.
        :type name: str
        """

        self._name = name
