from datetime import date, datetime  # noqa: F401
from typing import Dict, List  # noqa: F401

from timestep.api.openai.v1 import util
from timestep.api.openai.v1.models.base_model import Model
from timestep.api.openai.v1.models.create_chat_completion_stream_response_choices_inner import \
    CreateChatCompletionStreamResponseChoicesInner  # noqa: E501
from timestep.api.openai.v1.models.create_chat_completion_stream_response_usage import \
    CreateChatCompletionStreamResponseUsage  # noqa: E501


class CreateChatCompletionStreamResponse(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id=None, choices=None, created=None, model=None, service_tier=None, system_fingerprint=None, object=None, usage=None):  # noqa: E501
        """CreateChatCompletionStreamResponse - a model defined in OpenAPI

        :param id: The id of this CreateChatCompletionStreamResponse.  # noqa: E501
        :type id: str
        :param choices: The choices of this CreateChatCompletionStreamResponse.  # noqa: E501
        :type choices: List[CreateChatCompletionStreamResponseChoicesInner]
        :param created: The created of this CreateChatCompletionStreamResponse.  # noqa: E501
        :type created: int
        :param model: The model of this CreateChatCompletionStreamResponse.  # noqa: E501
        :type model: str
        :param service_tier: The service_tier of this CreateChatCompletionStreamResponse.  # noqa: E501
        :type service_tier: str
        :param system_fingerprint: The system_fingerprint of this CreateChatCompletionStreamResponse.  # noqa: E501
        :type system_fingerprint: str
        :param object: The object of this CreateChatCompletionStreamResponse.  # noqa: E501
        :type object: str
        :param usage: The usage of this CreateChatCompletionStreamResponse.  # noqa: E501
        :type usage: CreateChatCompletionStreamResponseUsage
        """
        self.openapi_types = {
            'id': str,
            'choices': List[CreateChatCompletionStreamResponseChoicesInner],
            'created': int,
            'model': str,
            'service_tier': str,
            'system_fingerprint': str,
            'object': str,
            'usage': CreateChatCompletionStreamResponseUsage
        }

        self.attribute_map = {
            'id': 'id',
            'choices': 'choices',
            'created': 'created',
            'model': 'model',
            'service_tier': 'service_tier',
            'system_fingerprint': 'system_fingerprint',
            'object': 'object',
            'usage': 'usage'
        }

        self._id = id
        self._choices = choices
        self._created = created
        self._model = model
        self._service_tier = service_tier
        self._system_fingerprint = system_fingerprint
        self._object = object
        self._usage = usage

    @classmethod
    def from_dict(cls, dikt) -> 'CreateChatCompletionStreamResponse':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The CreateChatCompletionStreamResponse of this CreateChatCompletionStreamResponse.  # noqa: E501
        :rtype: CreateChatCompletionStreamResponse
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self) -> str:
        """Gets the id of this CreateChatCompletionStreamResponse.

        A unique identifier for the chat completion. Each chunk has the same ID.  # noqa: E501

        :return: The id of this CreateChatCompletionStreamResponse.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id: str):
        """Sets the id of this CreateChatCompletionStreamResponse.

        A unique identifier for the chat completion. Each chunk has the same ID.  # noqa: E501

        :param id: The id of this CreateChatCompletionStreamResponse.
        :type id: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def choices(self) -> List[CreateChatCompletionStreamResponseChoicesInner]:
        """Gets the choices of this CreateChatCompletionStreamResponse.

        A list of chat completion choices. Can contain more than one elements if `n` is greater than 1. Can also be empty for the last chunk if you set `stream_options: {\"include_usage\": true}`.   # noqa: E501

        :return: The choices of this CreateChatCompletionStreamResponse.
        :rtype: List[CreateChatCompletionStreamResponseChoicesInner]
        """
        return self._choices

    @choices.setter
    def choices(self, choices: List[CreateChatCompletionStreamResponseChoicesInner]):
        """Sets the choices of this CreateChatCompletionStreamResponse.

        A list of chat completion choices. Can contain more than one elements if `n` is greater than 1. Can also be empty for the last chunk if you set `stream_options: {\"include_usage\": true}`.   # noqa: E501

        :param choices: The choices of this CreateChatCompletionStreamResponse.
        :type choices: List[CreateChatCompletionStreamResponseChoicesInner]
        """
        if choices is None:
            raise ValueError("Invalid value for `choices`, must not be `None`")  # noqa: E501

        self._choices = choices

    @property
    def created(self) -> int:
        """Gets the created of this CreateChatCompletionStreamResponse.

        The Unix timestamp (in seconds) of when the chat completion was created. Each chunk has the same timestamp.  # noqa: E501

        :return: The created of this CreateChatCompletionStreamResponse.
        :rtype: int
        """
        return self._created

    @created.setter
    def created(self, created: int):
        """Sets the created of this CreateChatCompletionStreamResponse.

        The Unix timestamp (in seconds) of when the chat completion was created. Each chunk has the same timestamp.  # noqa: E501

        :param created: The created of this CreateChatCompletionStreamResponse.
        :type created: int
        """
        if created is None:
            raise ValueError("Invalid value for `created`, must not be `None`")  # noqa: E501

        self._created = created

    @property
    def model(self) -> str:
        """Gets the model of this CreateChatCompletionStreamResponse.

        The model to generate the completion.  # noqa: E501

        :return: The model of this CreateChatCompletionStreamResponse.
        :rtype: str
        """
        return self._model

    @model.setter
    def model(self, model: str):
        """Sets the model of this CreateChatCompletionStreamResponse.

        The model to generate the completion.  # noqa: E501

        :param model: The model of this CreateChatCompletionStreamResponse.
        :type model: str
        """
        if model is None:
            raise ValueError("Invalid value for `model`, must not be `None`")  # noqa: E501

        self._model = model

    @property
    def service_tier(self) -> str:
        """Gets the service_tier of this CreateChatCompletionStreamResponse.

        The service tier used for processing the request. This field is only included if the `service_tier` parameter is specified in the request.  # noqa: E501

        :return: The service_tier of this CreateChatCompletionStreamResponse.
        :rtype: str
        """
        return self._service_tier

    @service_tier.setter
    def service_tier(self, service_tier: str):
        """Sets the service_tier of this CreateChatCompletionStreamResponse.

        The service tier used for processing the request. This field is only included if the `service_tier` parameter is specified in the request.  # noqa: E501

        :param service_tier: The service_tier of this CreateChatCompletionStreamResponse.
        :type service_tier: str
        """
        allowed_values = [None,"scale", "default"]  # noqa: E501
        if service_tier not in allowed_values:
            raise ValueError(
                "Invalid value for `service_tier` ({0}), must be one of {1}"
                .format(service_tier, allowed_values)
            )

        self._service_tier = service_tier

    @property
    def system_fingerprint(self) -> str:
        """Gets the system_fingerprint of this CreateChatCompletionStreamResponse.

        This fingerprint represents the backend configuration that the model runs with. Can be used in conjunction with the `seed` request parameter to understand when backend changes have been made that might impact determinism.   # noqa: E501

        :return: The system_fingerprint of this CreateChatCompletionStreamResponse.
        :rtype: str
        """
        return self._system_fingerprint

    @system_fingerprint.setter
    def system_fingerprint(self, system_fingerprint: str):
        """Sets the system_fingerprint of this CreateChatCompletionStreamResponse.

        This fingerprint represents the backend configuration that the model runs with. Can be used in conjunction with the `seed` request parameter to understand when backend changes have been made that might impact determinism.   # noqa: E501

        :param system_fingerprint: The system_fingerprint of this CreateChatCompletionStreamResponse.
        :type system_fingerprint: str
        """

        self._system_fingerprint = system_fingerprint

    @property
    def object(self) -> str:
        """Gets the object of this CreateChatCompletionStreamResponse.

        The object type, which is always `chat.completion.chunk`.  # noqa: E501

        :return: The object of this CreateChatCompletionStreamResponse.
        :rtype: str
        """
        return self._object

    @object.setter
    def object(self, object: str):
        """Sets the object of this CreateChatCompletionStreamResponse.

        The object type, which is always `chat.completion.chunk`.  # noqa: E501

        :param object: The object of this CreateChatCompletionStreamResponse.
        :type object: str
        """
        allowed_values = ["chat.completion.chunk"]  # noqa: E501
        if object not in allowed_values:
            raise ValueError(
                "Invalid value for `object` ({0}), must be one of {1}"
                .format(object, allowed_values)
            )

        self._object = object

    @property
    def usage(self) -> CreateChatCompletionStreamResponseUsage:
        """Gets the usage of this CreateChatCompletionStreamResponse.


        :return: The usage of this CreateChatCompletionStreamResponse.
        :rtype: CreateChatCompletionStreamResponseUsage
        """
        return self._usage

    @usage.setter
    def usage(self, usage: CreateChatCompletionStreamResponseUsage):
        """Sets the usage of this CreateChatCompletionStreamResponse.


        :param usage: The usage of this CreateChatCompletionStreamResponse.
        :type usage: CreateChatCompletionStreamResponseUsage
        """

        self._usage = usage
