from datetime import date, datetime  # noqa: F401
from typing import Dict, List  # noqa: F401

from timestep.api.openai.v1 import util
from timestep.api.openai.v1.models.base_model import Model
from timestep.api.openai.v1.models.create_moderation_response_results_inner import \
    CreateModerationResponseResultsInner  # noqa: E501


class CreateModerationResponse(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id=None, model=None, results=None):  # noqa: E501
        """CreateModerationResponse - a model defined in OpenAPI

        :param id: The id of this CreateModerationResponse.  # noqa: E501
        :type id: str
        :param model: The model of this CreateModerationResponse.  # noqa: E501
        :type model: str
        :param results: The results of this CreateModerationResponse.  # noqa: E501
        :type results: List[CreateModerationResponseResultsInner]
        """
        self.openapi_types = {
            'id': str,
            'model': str,
            'results': List[CreateModerationResponseResultsInner]
        }

        self.attribute_map = {
            'id': 'id',
            'model': 'model',
            'results': 'results'
        }

        self._id = id
        self._model = model
        self._results = results

    @classmethod
    def from_dict(cls, dikt) -> 'CreateModerationResponse':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The CreateModerationResponse of this CreateModerationResponse.  # noqa: E501
        :rtype: CreateModerationResponse
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self) -> str:
        """Gets the id of this CreateModerationResponse.

        The unique identifier for the moderation request.  # noqa: E501

        :return: The id of this CreateModerationResponse.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id: str):
        """Sets the id of this CreateModerationResponse.

        The unique identifier for the moderation request.  # noqa: E501

        :param id: The id of this CreateModerationResponse.
        :type id: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def model(self) -> str:
        """Gets the model of this CreateModerationResponse.

        The model used to generate the moderation results.  # noqa: E501

        :return: The model of this CreateModerationResponse.
        :rtype: str
        """
        return self._model

    @model.setter
    def model(self, model: str):
        """Sets the model of this CreateModerationResponse.

        The model used to generate the moderation results.  # noqa: E501

        :param model: The model of this CreateModerationResponse.
        :type model: str
        """
        if model is None:
            raise ValueError("Invalid value for `model`, must not be `None`")  # noqa: E501

        self._model = model

    @property
    def results(self) -> List[CreateModerationResponseResultsInner]:
        """Gets the results of this CreateModerationResponse.

        A list of moderation objects.  # noqa: E501

        :return: The results of this CreateModerationResponse.
        :rtype: List[CreateModerationResponseResultsInner]
        """
        return self._results

    @results.setter
    def results(self, results: List[CreateModerationResponseResultsInner]):
        """Sets the results of this CreateModerationResponse.

        A list of moderation objects.  # noqa: E501

        :param results: The results of this CreateModerationResponse.
        :type results: List[CreateModerationResponseResultsInner]
        """
        if results is None:
            raise ValueError("Invalid value for `results`, must not be `None`")  # noqa: E501

        self._results = results
