from datetime import date, datetime  # noqa: F401
from typing import Dict, List  # noqa: F401

from timestep.api.openai.v1 import util
from timestep.api.openai.v1.models.base_model import Model
from timestep.api.openai.v1.models.chunking_strategy_request_param import \
    ChunkingStrategyRequestParam  # noqa: E501


class CreateVectorStoreFileRequest(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, file_id=None, chunking_strategy=None):  # noqa: E501
        """CreateVectorStoreFileRequest - a model defined in OpenAPI

        :param file_id: The file_id of this CreateVectorStoreFileRequest.  # noqa: E501
        :type file_id: str
        :param chunking_strategy: The chunking_strategy of this CreateVectorStoreFileRequest.  # noqa: E501
        :type chunking_strategy: ChunkingStrategyRequestParam
        """
        self.openapi_types = {
            'file_id': str,
            'chunking_strategy': ChunkingStrategyRequestParam
        }

        self.attribute_map = {
            'file_id': 'file_id',
            'chunking_strategy': 'chunking_strategy'
        }

        self._file_id = file_id
        self._chunking_strategy = chunking_strategy

    @classmethod
    def from_dict(cls, dikt) -> 'CreateVectorStoreFileRequest':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The CreateVectorStoreFileRequest of this CreateVectorStoreFileRequest.  # noqa: E501
        :rtype: CreateVectorStoreFileRequest
        """
        return util.deserialize_model(dikt, cls)

    @property
    def file_id(self) -> str:
        """Gets the file_id of this CreateVectorStoreFileRequest.

        A [File](/docs/api-reference/files) ID that the vector store should use. Useful for tools like `file_search` that can access files.  # noqa: E501

        :return: The file_id of this CreateVectorStoreFileRequest.
        :rtype: str
        """
        return self._file_id

    @file_id.setter
    def file_id(self, file_id: str):
        """Sets the file_id of this CreateVectorStoreFileRequest.

        A [File](/docs/api-reference/files) ID that the vector store should use. Useful for tools like `file_search` that can access files.  # noqa: E501

        :param file_id: The file_id of this CreateVectorStoreFileRequest.
        :type file_id: str
        """
        if file_id is None:
            raise ValueError("Invalid value for `file_id`, must not be `None`")  # noqa: E501

        self._file_id = file_id

    @property
    def chunking_strategy(self) -> ChunkingStrategyRequestParam:
        """Gets the chunking_strategy of this CreateVectorStoreFileRequest.


        :return: The chunking_strategy of this CreateVectorStoreFileRequest.
        :rtype: ChunkingStrategyRequestParam
        """
        return self._chunking_strategy

    @chunking_strategy.setter
    def chunking_strategy(self, chunking_strategy: ChunkingStrategyRequestParam):
        """Sets the chunking_strategy of this CreateVectorStoreFileRequest.


        :param chunking_strategy: The chunking_strategy of this CreateVectorStoreFileRequest.
        :type chunking_strategy: ChunkingStrategyRequestParam
        """

        self._chunking_strategy = chunking_strategy
