from datetime import date, datetime  # noqa: F401
from typing import Dict, List  # noqa: F401

from timestep.api.openai.v1 import util
from timestep.api.openai.v1.models.base_model import Model
from timestep.api.openai.v1.models.create_fine_tuning_job_request_integrations_inner_wandb import \
    CreateFineTuningJobRequestIntegrationsInnerWandb  # noqa: E501


class FineTuningIntegration(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, type=None, wandb=None):  # noqa: E501
        """FineTuningIntegration - a model defined in OpenAPI

        :param type: The type of this FineTuningIntegration.  # noqa: E501
        :type type: str
        :param wandb: The wandb of this FineTuningIntegration.  # noqa: E501
        :type wandb: CreateFineTuningJobRequestIntegrationsInnerWandb
        """
        self.openapi_types = {
            'type': str,
            'wandb': CreateFineTuningJobRequestIntegrationsInnerWandb
        }

        self.attribute_map = {
            'type': 'type',
            'wandb': 'wandb'
        }

        self._type = type
        self._wandb = wandb

    @classmethod
    def from_dict(cls, dikt) -> 'FineTuningIntegration':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The FineTuningIntegration of this FineTuningIntegration.  # noqa: E501
        :rtype: FineTuningIntegration
        """
        return util.deserialize_model(dikt, cls)

    @property
    def type(self) -> str:
        """Gets the type of this FineTuningIntegration.

        The type of the integration being enabled for the fine-tuning job  # noqa: E501

        :return: The type of this FineTuningIntegration.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type: str):
        """Sets the type of this FineTuningIntegration.

        The type of the integration being enabled for the fine-tuning job  # noqa: E501

        :param type: The type of this FineTuningIntegration.
        :type type: str
        """
        allowed_values = ["wandb"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def wandb(self) -> CreateFineTuningJobRequestIntegrationsInnerWandb:
        """Gets the wandb of this FineTuningIntegration.


        :return: The wandb of this FineTuningIntegration.
        :rtype: CreateFineTuningJobRequestIntegrationsInnerWandb
        """
        return self._wandb

    @wandb.setter
    def wandb(self, wandb: CreateFineTuningJobRequestIntegrationsInnerWandb):
        """Sets the wandb of this FineTuningIntegration.


        :param wandb: The wandb of this FineTuningIntegration.
        :type wandb: CreateFineTuningJobRequestIntegrationsInnerWandb
        """
        if wandb is None:
            raise ValueError("Invalid value for `wandb`, must not be `None`")  # noqa: E501

        self._wandb = wandb
