from datetime import date, datetime  # noqa: F401
from typing import Dict, List  # noqa: F401

from timestep.api.openai.v1 import util
from timestep.api.openai.v1.models.base_model import Model
from timestep.api.openai.v1.models.chat_completion_message_tool_call import \
    ChatCompletionMessageToolCall  # noqa: E501
from timestep.api.openai.v1.models.chat_completion_request_assistant_message_function_call import \
    ChatCompletionRequestAssistantMessageFunctionCall  # noqa: E501
from timestep.api.openai.v1.models.chat_completion_request_function_message import \
    ChatCompletionRequestFunctionMessage  # noqa: E501
from timestep.api.openai.v1.models.chat_completion_request_system_message import \
    ChatCompletionRequestSystemMessage  # noqa: E501
from timestep.api.openai.v1.models.chat_completion_request_tool_message import \
    ChatCompletionRequestToolMessage  # noqa: E501
from timestep.api.openai.v1.models.chat_completion_request_user_message import \
    ChatCompletionRequestUserMessage  # noqa: E501
from timestep.api.openai.v1.models.fine_tune_chat_completion_request_assistant_message import \
    FineTuneChatCompletionRequestAssistantMessage  # noqa: E501


class FinetuneChatRequestInputMessagesInner(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, content=None, role=None, name=None, weight=None, tool_calls=None, function_call=None, tool_call_id=None):  # noqa: E501
        """FinetuneChatRequestInputMessagesInner - a model defined in OpenAPI

        :param content: The content of this FinetuneChatRequestInputMessagesInner.  # noqa: E501
        :type content: str
        :param role: The role of this FinetuneChatRequestInputMessagesInner.  # noqa: E501
        :type role: str
        :param name: The name of this FinetuneChatRequestInputMessagesInner.  # noqa: E501
        :type name: str
        :param weight: The weight of this FinetuneChatRequestInputMessagesInner.  # noqa: E501
        :type weight: int
        :param tool_calls: The tool_calls of this FinetuneChatRequestInputMessagesInner.  # noqa: E501
        :type tool_calls: List[ChatCompletionMessageToolCall]
        :param function_call: The function_call of this FinetuneChatRequestInputMessagesInner.  # noqa: E501
        :type function_call: ChatCompletionRequestAssistantMessageFunctionCall
        :param tool_call_id: The tool_call_id of this FinetuneChatRequestInputMessagesInner.  # noqa: E501
        :type tool_call_id: str
        """
        self.openapi_types = {
            'content': str,
            'role': str,
            'name': str,
            'weight': int,
            'tool_calls': List[ChatCompletionMessageToolCall],
            'function_call': ChatCompletionRequestAssistantMessageFunctionCall,
            'tool_call_id': str
        }

        self.attribute_map = {
            'content': 'content',
            'role': 'role',
            'name': 'name',
            'weight': 'weight',
            'tool_calls': 'tool_calls',
            'function_call': 'function_call',
            'tool_call_id': 'tool_call_id'
        }

        self._content = content
        self._role = role
        self._name = name
        self._weight = weight
        self._tool_calls = tool_calls
        self._function_call = function_call
        self._tool_call_id = tool_call_id

    @classmethod
    def from_dict(cls, dikt) -> 'FinetuneChatRequestInputMessagesInner':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The FinetuneChatRequestInput_messages_inner of this FinetuneChatRequestInputMessagesInner.  # noqa: E501
        :rtype: FinetuneChatRequestInputMessagesInner
        """
        return util.deserialize_model(dikt, cls)

    @property
    def content(self) -> str:
        """Gets the content of this FinetuneChatRequestInputMessagesInner.

        The contents of the function message.  # noqa: E501

        :return: The content of this FinetuneChatRequestInputMessagesInner.
        :rtype: str
        """
        return self._content

    @content.setter
    def content(self, content: str):
        """Sets the content of this FinetuneChatRequestInputMessagesInner.

        The contents of the function message.  # noqa: E501

        :param content: The content of this FinetuneChatRequestInputMessagesInner.
        :type content: str
        """
        if content is None:
            raise ValueError("Invalid value for `content`, must not be `None`")  # noqa: E501

        self._content = content

    @property
    def role(self) -> str:
        """Gets the role of this FinetuneChatRequestInputMessagesInner.

        The role of the messages author, in this case `function`.  # noqa: E501

        :return: The role of this FinetuneChatRequestInputMessagesInner.
        :rtype: str
        """
        return self._role

    @role.setter
    def role(self, role: str):
        """Sets the role of this FinetuneChatRequestInputMessagesInner.

        The role of the messages author, in this case `function`.  # noqa: E501

        :param role: The role of this FinetuneChatRequestInputMessagesInner.
        :type role: str
        """
        allowed_values = ["function"]  # noqa: E501
        if role not in allowed_values:
            raise ValueError(
                "Invalid value for `role` ({0}), must be one of {1}"
                .format(role, allowed_values)
            )

        self._role = role

    @property
    def name(self) -> str:
        """Gets the name of this FinetuneChatRequestInputMessagesInner.

        The name of the function to call.  # noqa: E501

        :return: The name of this FinetuneChatRequestInputMessagesInner.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name: str):
        """Sets the name of this FinetuneChatRequestInputMessagesInner.

        The name of the function to call.  # noqa: E501

        :param name: The name of this FinetuneChatRequestInputMessagesInner.
        :type name: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def weight(self) -> int:
        """Gets the weight of this FinetuneChatRequestInputMessagesInner.

        Controls whether the assistant message is trained against (0 or 1)  # noqa: E501

        :return: The weight of this FinetuneChatRequestInputMessagesInner.
        :rtype: int
        """
        return self._weight

    @weight.setter
    def weight(self, weight: int):
        """Sets the weight of this FinetuneChatRequestInputMessagesInner.

        Controls whether the assistant message is trained against (0 or 1)  # noqa: E501

        :param weight: The weight of this FinetuneChatRequestInputMessagesInner.
        :type weight: int
        """
        allowed_values = [0, 1]  # noqa: E501
        if weight not in allowed_values:
            raise ValueError(
                "Invalid value for `weight` ({0}), must be one of {1}"
                .format(weight, allowed_values)
            )

        self._weight = weight

    @property
    def tool_calls(self) -> List[ChatCompletionMessageToolCall]:
        """Gets the tool_calls of this FinetuneChatRequestInputMessagesInner.

        The tool calls generated by the model, such as function calls.  # noqa: E501

        :return: The tool_calls of this FinetuneChatRequestInputMessagesInner.
        :rtype: List[ChatCompletionMessageToolCall]
        """
        return self._tool_calls

    @tool_calls.setter
    def tool_calls(self, tool_calls: List[ChatCompletionMessageToolCall]):
        """Sets the tool_calls of this FinetuneChatRequestInputMessagesInner.

        The tool calls generated by the model, such as function calls.  # noqa: E501

        :param tool_calls: The tool_calls of this FinetuneChatRequestInputMessagesInner.
        :type tool_calls: List[ChatCompletionMessageToolCall]
        """

        self._tool_calls = tool_calls

    @property
    def function_call(self) -> ChatCompletionRequestAssistantMessageFunctionCall:
        """Gets the function_call of this FinetuneChatRequestInputMessagesInner.


        :return: The function_call of this FinetuneChatRequestInputMessagesInner.
        :rtype: ChatCompletionRequestAssistantMessageFunctionCall
        """
        return self._function_call

    @function_call.setter
    def function_call(self, function_call: ChatCompletionRequestAssistantMessageFunctionCall):
        """Sets the function_call of this FinetuneChatRequestInputMessagesInner.


        :param function_call: The function_call of this FinetuneChatRequestInputMessagesInner.
        :type function_call: ChatCompletionRequestAssistantMessageFunctionCall
        """

        self._function_call = function_call

    @property
    def tool_call_id(self) -> str:
        """Gets the tool_call_id of this FinetuneChatRequestInputMessagesInner.

        Tool call that this message is responding to.  # noqa: E501

        :return: The tool_call_id of this FinetuneChatRequestInputMessagesInner.
        :rtype: str
        """
        return self._tool_call_id

    @tool_call_id.setter
    def tool_call_id(self, tool_call_id: str):
        """Sets the tool_call_id of this FinetuneChatRequestInputMessagesInner.

        Tool call that this message is responding to.  # noqa: E501

        :param tool_call_id: The tool_call_id of this FinetuneChatRequestInputMessagesInner.
        :type tool_call_id: str
        """
        if tool_call_id is None:
            raise ValueError("Invalid value for `tool_call_id`, must not be `None`")  # noqa: E501

        self._tool_call_id = tool_call_id
