from datetime import date, datetime  # noqa: F401
from typing import Dict, List  # noqa: F401

from timestep.api.openai.v1 import util
from timestep.api.openai.v1.models.base_model import Model
from timestep.api.openai.v1.models.message_content_text_annotations_file_citation_object import \
    MessageContentTextAnnotationsFileCitationObject  # noqa: E501
from timestep.api.openai.v1.models.message_content_text_annotations_file_citation_object_file_citation import \
    MessageContentTextAnnotationsFileCitationObjectFileCitation  # noqa: E501
from timestep.api.openai.v1.models.message_content_text_annotations_file_path_object import \
    MessageContentTextAnnotationsFilePathObject  # noqa: E501
from timestep.api.openai.v1.models.message_content_text_annotations_file_path_object_file_path import \
    MessageContentTextAnnotationsFilePathObjectFilePath  # noqa: E501


class MessageContentTextObjectTextAnnotationsInner(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, type=None, text=None, file_citation=None, start_index=None, end_index=None, file_path=None):  # noqa: E501
        """MessageContentTextObjectTextAnnotationsInner - a model defined in OpenAPI

        :param type: The type of this MessageContentTextObjectTextAnnotationsInner.  # noqa: E501
        :type type: str
        :param text: The text of this MessageContentTextObjectTextAnnotationsInner.  # noqa: E501
        :type text: str
        :param file_citation: The file_citation of this MessageContentTextObjectTextAnnotationsInner.  # noqa: E501
        :type file_citation: MessageContentTextAnnotationsFileCitationObjectFileCitation
        :param start_index: The start_index of this MessageContentTextObjectTextAnnotationsInner.  # noqa: E501
        :type start_index: int
        :param end_index: The end_index of this MessageContentTextObjectTextAnnotationsInner.  # noqa: E501
        :type end_index: int
        :param file_path: The file_path of this MessageContentTextObjectTextAnnotationsInner.  # noqa: E501
        :type file_path: MessageContentTextAnnotationsFilePathObjectFilePath
        """
        self.openapi_types = {
            'type': str,
            'text': str,
            'file_citation': MessageContentTextAnnotationsFileCitationObjectFileCitation,
            'start_index': int,
            'end_index': int,
            'file_path': MessageContentTextAnnotationsFilePathObjectFilePath
        }

        self.attribute_map = {
            'type': 'type',
            'text': 'text',
            'file_citation': 'file_citation',
            'start_index': 'start_index',
            'end_index': 'end_index',
            'file_path': 'file_path'
        }

        self._type = type
        self._text = text
        self._file_citation = file_citation
        self._start_index = start_index
        self._end_index = end_index
        self._file_path = file_path

    @classmethod
    def from_dict(cls, dikt) -> 'MessageContentTextObjectTextAnnotationsInner':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The MessageContentTextObject_text_annotations_inner of this MessageContentTextObjectTextAnnotationsInner.  # noqa: E501
        :rtype: MessageContentTextObjectTextAnnotationsInner
        """
        return util.deserialize_model(dikt, cls)

    @property
    def type(self) -> str:
        """Gets the type of this MessageContentTextObjectTextAnnotationsInner.

        Always `file_citation`.  # noqa: E501

        :return: The type of this MessageContentTextObjectTextAnnotationsInner.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type: str):
        """Sets the type of this MessageContentTextObjectTextAnnotationsInner.

        Always `file_citation`.  # noqa: E501

        :param type: The type of this MessageContentTextObjectTextAnnotationsInner.
        :type type: str
        """
        allowed_values = ["file_citation", "file_path"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def text(self) -> str:
        """Gets the text of this MessageContentTextObjectTextAnnotationsInner.

        The text in the message content that needs to be replaced.  # noqa: E501

        :return: The text of this MessageContentTextObjectTextAnnotationsInner.
        :rtype: str
        """
        return self._text

    @text.setter
    def text(self, text: str):
        """Sets the text of this MessageContentTextObjectTextAnnotationsInner.

        The text in the message content that needs to be replaced.  # noqa: E501

        :param text: The text of this MessageContentTextObjectTextAnnotationsInner.
        :type text: str
        """
        if text is None:
            raise ValueError("Invalid value for `text`, must not be `None`")  # noqa: E501

        self._text = text

    @property
    def file_citation(self) -> MessageContentTextAnnotationsFileCitationObjectFileCitation:
        """Gets the file_citation of this MessageContentTextObjectTextAnnotationsInner.


        :return: The file_citation of this MessageContentTextObjectTextAnnotationsInner.
        :rtype: MessageContentTextAnnotationsFileCitationObjectFileCitation
        """
        return self._file_citation

    @file_citation.setter
    def file_citation(self, file_citation: MessageContentTextAnnotationsFileCitationObjectFileCitation):
        """Sets the file_citation of this MessageContentTextObjectTextAnnotationsInner.


        :param file_citation: The file_citation of this MessageContentTextObjectTextAnnotationsInner.
        :type file_citation: MessageContentTextAnnotationsFileCitationObjectFileCitation
        """
        if file_citation is None:
            raise ValueError("Invalid value for `file_citation`, must not be `None`")  # noqa: E501

        self._file_citation = file_citation

    @property
    def start_index(self) -> int:
        """Gets the start_index of this MessageContentTextObjectTextAnnotationsInner.


        :return: The start_index of this MessageContentTextObjectTextAnnotationsInner.
        :rtype: int
        """
        return self._start_index

    @start_index.setter
    def start_index(self, start_index: int):
        """Sets the start_index of this MessageContentTextObjectTextAnnotationsInner.


        :param start_index: The start_index of this MessageContentTextObjectTextAnnotationsInner.
        :type start_index: int
        """
        if start_index is None:
            raise ValueError("Invalid value for `start_index`, must not be `None`")  # noqa: E501
        if start_index is not None and start_index < 0:  # noqa: E501
            raise ValueError("Invalid value for `start_index`, must be a value greater than or equal to `0`")  # noqa: E501

        self._start_index = start_index

    @property
    def end_index(self) -> int:
        """Gets the end_index of this MessageContentTextObjectTextAnnotationsInner.


        :return: The end_index of this MessageContentTextObjectTextAnnotationsInner.
        :rtype: int
        """
        return self._end_index

    @end_index.setter
    def end_index(self, end_index: int):
        """Sets the end_index of this MessageContentTextObjectTextAnnotationsInner.


        :param end_index: The end_index of this MessageContentTextObjectTextAnnotationsInner.
        :type end_index: int
        """
        if end_index is None:
            raise ValueError("Invalid value for `end_index`, must not be `None`")  # noqa: E501
        if end_index is not None and end_index < 0:  # noqa: E501
            raise ValueError("Invalid value for `end_index`, must be a value greater than or equal to `0`")  # noqa: E501

        self._end_index = end_index

    @property
    def file_path(self) -> MessageContentTextAnnotationsFilePathObjectFilePath:
        """Gets the file_path of this MessageContentTextObjectTextAnnotationsInner.


        :return: The file_path of this MessageContentTextObjectTextAnnotationsInner.
        :rtype: MessageContentTextAnnotationsFilePathObjectFilePath
        """
        return self._file_path

    @file_path.setter
    def file_path(self, file_path: MessageContentTextAnnotationsFilePathObjectFilePath):
        """Sets the file_path of this MessageContentTextObjectTextAnnotationsInner.


        :param file_path: The file_path of this MessageContentTextObjectTextAnnotationsInner.
        :type file_path: MessageContentTextAnnotationsFilePathObjectFilePath
        """
        if file_path is None:
            raise ValueError("Invalid value for `file_path`, must not be `None`")  # noqa: E501

        self._file_path = file_path
