from datetime import date, datetime  # noqa: F401
from typing import Dict, List  # noqa: F401

from timestep.api.openai.v1 import util
from timestep.api.openai.v1.models.base_model import Model
from timestep.api.openai.v1.models.message_delta_content_image_url_object_image_url import \
    MessageDeltaContentImageUrlObjectImageUrl  # noqa: E501


class MessageDeltaContentImageUrlObject(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, index=None, type=None, image_url=None):  # noqa: E501
        """MessageDeltaContentImageUrlObject - a model defined in OpenAPI

        :param index: The index of this MessageDeltaContentImageUrlObject.  # noqa: E501
        :type index: int
        :param type: The type of this MessageDeltaContentImageUrlObject.  # noqa: E501
        :type type: str
        :param image_url: The image_url of this MessageDeltaContentImageUrlObject.  # noqa: E501
        :type image_url: MessageDeltaContentImageUrlObjectImageUrl
        """
        self.openapi_types = {
            'index': int,
            'type': str,
            'image_url': MessageDeltaContentImageUrlObjectImageUrl
        }

        self.attribute_map = {
            'index': 'index',
            'type': 'type',
            'image_url': 'image_url'
        }

        self._index = index
        self._type = type
        self._image_url = image_url

    @classmethod
    def from_dict(cls, dikt) -> 'MessageDeltaContentImageUrlObject':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The MessageDeltaContentImageUrlObject of this MessageDeltaContentImageUrlObject.  # noqa: E501
        :rtype: MessageDeltaContentImageUrlObject
        """
        return util.deserialize_model(dikt, cls)

    @property
    def index(self) -> int:
        """Gets the index of this MessageDeltaContentImageUrlObject.

        The index of the content part in the message.  # noqa: E501

        :return: The index of this MessageDeltaContentImageUrlObject.
        :rtype: int
        """
        return self._index

    @index.setter
    def index(self, index: int):
        """Sets the index of this MessageDeltaContentImageUrlObject.

        The index of the content part in the message.  # noqa: E501

        :param index: The index of this MessageDeltaContentImageUrlObject.
        :type index: int
        """
        if index is None:
            raise ValueError("Invalid value for `index`, must not be `None`")  # noqa: E501

        self._index = index

    @property
    def type(self) -> str:
        """Gets the type of this MessageDeltaContentImageUrlObject.

        Always `image_url`.  # noqa: E501

        :return: The type of this MessageDeltaContentImageUrlObject.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type: str):
        """Sets the type of this MessageDeltaContentImageUrlObject.

        Always `image_url`.  # noqa: E501

        :param type: The type of this MessageDeltaContentImageUrlObject.
        :type type: str
        """
        allowed_values = ["image_url"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def image_url(self) -> MessageDeltaContentImageUrlObjectImageUrl:
        """Gets the image_url of this MessageDeltaContentImageUrlObject.


        :return: The image_url of this MessageDeltaContentImageUrlObject.
        :rtype: MessageDeltaContentImageUrlObjectImageUrl
        """
        return self._image_url

    @image_url.setter
    def image_url(self, image_url: MessageDeltaContentImageUrlObjectImageUrl):
        """Sets the image_url of this MessageDeltaContentImageUrlObject.


        :param image_url: The image_url of this MessageDeltaContentImageUrlObject.
        :type image_url: MessageDeltaContentImageUrlObjectImageUrl
        """

        self._image_url = image_url
