from datetime import date, datetime  # noqa: F401
from typing import Dict, List  # noqa: F401

from timestep.api.openai.v1 import util
from timestep.api.openai.v1.models.base_model import Model


class RunStepCompletionUsage(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, completion_tokens=None, prompt_tokens=None, total_tokens=None):  # noqa: E501
        """RunStepCompletionUsage - a model defined in OpenAPI

        :param completion_tokens: The completion_tokens of this RunStepCompletionUsage.  # noqa: E501
        :type completion_tokens: int
        :param prompt_tokens: The prompt_tokens of this RunStepCompletionUsage.  # noqa: E501
        :type prompt_tokens: int
        :param total_tokens: The total_tokens of this RunStepCompletionUsage.  # noqa: E501
        :type total_tokens: int
        """
        self.openapi_types = {
            'completion_tokens': int,
            'prompt_tokens': int,
            'total_tokens': int
        }

        self.attribute_map = {
            'completion_tokens': 'completion_tokens',
            'prompt_tokens': 'prompt_tokens',
            'total_tokens': 'total_tokens'
        }

        self._completion_tokens = completion_tokens
        self._prompt_tokens = prompt_tokens
        self._total_tokens = total_tokens

    @classmethod
    def from_dict(cls, dikt) -> 'RunStepCompletionUsage':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The RunStepCompletionUsage of this RunStepCompletionUsage.  # noqa: E501
        :rtype: RunStepCompletionUsage
        """
        return util.deserialize_model(dikt, cls)

    @property
    def completion_tokens(self) -> int:
        """Gets the completion_tokens of this RunStepCompletionUsage.

        Number of completion tokens used over the course of the run step.  # noqa: E501

        :return: The completion_tokens of this RunStepCompletionUsage.
        :rtype: int
        """
        return self._completion_tokens

    @completion_tokens.setter
    def completion_tokens(self, completion_tokens: int):
        """Sets the completion_tokens of this RunStepCompletionUsage.

        Number of completion tokens used over the course of the run step.  # noqa: E501

        :param completion_tokens: The completion_tokens of this RunStepCompletionUsage.
        :type completion_tokens: int
        """
        if completion_tokens is None:
            raise ValueError("Invalid value for `completion_tokens`, must not be `None`")  # noqa: E501

        self._completion_tokens = completion_tokens

    @property
    def prompt_tokens(self) -> int:
        """Gets the prompt_tokens of this RunStepCompletionUsage.

        Number of prompt tokens used over the course of the run step.  # noqa: E501

        :return: The prompt_tokens of this RunStepCompletionUsage.
        :rtype: int
        """
        return self._prompt_tokens

    @prompt_tokens.setter
    def prompt_tokens(self, prompt_tokens: int):
        """Sets the prompt_tokens of this RunStepCompletionUsage.

        Number of prompt tokens used over the course of the run step.  # noqa: E501

        :param prompt_tokens: The prompt_tokens of this RunStepCompletionUsage.
        :type prompt_tokens: int
        """
        if prompt_tokens is None:
            raise ValueError("Invalid value for `prompt_tokens`, must not be `None`")  # noqa: E501

        self._prompt_tokens = prompt_tokens

    @property
    def total_tokens(self) -> int:
        """Gets the total_tokens of this RunStepCompletionUsage.

        Total number of tokens used (prompt + completion).  # noqa: E501

        :return: The total_tokens of this RunStepCompletionUsage.
        :rtype: int
        """
        return self._total_tokens

    @total_tokens.setter
    def total_tokens(self, total_tokens: int):
        """Sets the total_tokens of this RunStepCompletionUsage.

        Total number of tokens used (prompt + completion).  # noqa: E501

        :param total_tokens: The total_tokens of this RunStepCompletionUsage.
        :type total_tokens: int
        """
        if total_tokens is None:
            raise ValueError("Invalid value for `total_tokens`, must not be `None`")  # noqa: E501

        self._total_tokens = total_tokens
