from datetime import date, datetime  # noqa: F401
from typing import Dict, List  # noqa: F401

from timestep.api.openai.v1 import util
from timestep.api.openai.v1.models.base_model import Model
from timestep.api.openai.v1.models.run_step_delta_object_delta import \
    RunStepDeltaObjectDelta  # noqa: E501


class RunStepDeltaObject(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id=None, object=None, delta=None):  # noqa: E501
        """RunStepDeltaObject - a model defined in OpenAPI

        :param id: The id of this RunStepDeltaObject.  # noqa: E501
        :type id: str
        :param object: The object of this RunStepDeltaObject.  # noqa: E501
        :type object: str
        :param delta: The delta of this RunStepDeltaObject.  # noqa: E501
        :type delta: RunStepDeltaObjectDelta
        """
        self.openapi_types = {
            'id': str,
            'object': str,
            'delta': RunStepDeltaObjectDelta
        }

        self.attribute_map = {
            'id': 'id',
            'object': 'object',
            'delta': 'delta'
        }

        self._id = id
        self._object = object
        self._delta = delta

    @classmethod
    def from_dict(cls, dikt) -> 'RunStepDeltaObject':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The RunStepDeltaObject of this RunStepDeltaObject.  # noqa: E501
        :rtype: RunStepDeltaObject
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self) -> str:
        """Gets the id of this RunStepDeltaObject.

        The identifier of the run step, which can be referenced in API endpoints.  # noqa: E501

        :return: The id of this RunStepDeltaObject.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id: str):
        """Sets the id of this RunStepDeltaObject.

        The identifier of the run step, which can be referenced in API endpoints.  # noqa: E501

        :param id: The id of this RunStepDeltaObject.
        :type id: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def object(self) -> str:
        """Gets the object of this RunStepDeltaObject.

        The object type, which is always `thread.run.step.delta`.  # noqa: E501

        :return: The object of this RunStepDeltaObject.
        :rtype: str
        """
        return self._object

    @object.setter
    def object(self, object: str):
        """Sets the object of this RunStepDeltaObject.

        The object type, which is always `thread.run.step.delta`.  # noqa: E501

        :param object: The object of this RunStepDeltaObject.
        :type object: str
        """
        allowed_values = ["thread.run.step.delta"]  # noqa: E501
        if object not in allowed_values:
            raise ValueError(
                "Invalid value for `object` ({0}), must be one of {1}"
                .format(object, allowed_values)
            )

        self._object = object

    @property
    def delta(self) -> RunStepDeltaObjectDelta:
        """Gets the delta of this RunStepDeltaObject.


        :return: The delta of this RunStepDeltaObject.
        :rtype: RunStepDeltaObjectDelta
        """
        return self._delta

    @delta.setter
    def delta(self, delta: RunStepDeltaObjectDelta):
        """Sets the delta of this RunStepDeltaObject.


        :param delta: The delta of this RunStepDeltaObject.
        :type delta: RunStepDeltaObjectDelta
        """
        if delta is None:
            raise ValueError("Invalid value for `delta`, must not be `None`")  # noqa: E501

        self._delta = delta
