from datetime import date, datetime  # noqa: F401
from typing import Dict, List  # noqa: F401

from timestep.api.openai.v1 import util
from timestep.api.openai.v1.models.base_model import Model
from timestep.api.openai.v1.models.run_step_delta_step_details_tool_calls_function_object_function import \
    RunStepDeltaStepDetailsToolCallsFunctionObjectFunction  # noqa: E501


class RunStepDeltaStepDetailsToolCallsFunctionObject(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, index=None, id=None, type=None, function=None):  # noqa: E501
        """RunStepDeltaStepDetailsToolCallsFunctionObject - a model defined in OpenAPI

        :param index: The index of this RunStepDeltaStepDetailsToolCallsFunctionObject.  # noqa: E501
        :type index: int
        :param id: The id of this RunStepDeltaStepDetailsToolCallsFunctionObject.  # noqa: E501
        :type id: str
        :param type: The type of this RunStepDeltaStepDetailsToolCallsFunctionObject.  # noqa: E501
        :type type: str
        :param function: The function of this RunStepDeltaStepDetailsToolCallsFunctionObject.  # noqa: E501
        :type function: RunStepDeltaStepDetailsToolCallsFunctionObjectFunction
        """
        self.openapi_types = {
            'index': int,
            'id': str,
            'type': str,
            'function': RunStepDeltaStepDetailsToolCallsFunctionObjectFunction
        }

        self.attribute_map = {
            'index': 'index',
            'id': 'id',
            'type': 'type',
            'function': 'function'
        }

        self._index = index
        self._id = id
        self._type = type
        self._function = function

    @classmethod
    def from_dict(cls, dikt) -> 'RunStepDeltaStepDetailsToolCallsFunctionObject':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The RunStepDeltaStepDetailsToolCallsFunctionObject of this RunStepDeltaStepDetailsToolCallsFunctionObject.  # noqa: E501
        :rtype: RunStepDeltaStepDetailsToolCallsFunctionObject
        """
        return util.deserialize_model(dikt, cls)

    @property
    def index(self) -> int:
        """Gets the index of this RunStepDeltaStepDetailsToolCallsFunctionObject.

        The index of the tool call in the tool calls array.  # noqa: E501

        :return: The index of this RunStepDeltaStepDetailsToolCallsFunctionObject.
        :rtype: int
        """
        return self._index

    @index.setter
    def index(self, index: int):
        """Sets the index of this RunStepDeltaStepDetailsToolCallsFunctionObject.

        The index of the tool call in the tool calls array.  # noqa: E501

        :param index: The index of this RunStepDeltaStepDetailsToolCallsFunctionObject.
        :type index: int
        """
        if index is None:
            raise ValueError("Invalid value for `index`, must not be `None`")  # noqa: E501

        self._index = index

    @property
    def id(self) -> str:
        """Gets the id of this RunStepDeltaStepDetailsToolCallsFunctionObject.

        The ID of the tool call object.  # noqa: E501

        :return: The id of this RunStepDeltaStepDetailsToolCallsFunctionObject.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id: str):
        """Sets the id of this RunStepDeltaStepDetailsToolCallsFunctionObject.

        The ID of the tool call object.  # noqa: E501

        :param id: The id of this RunStepDeltaStepDetailsToolCallsFunctionObject.
        :type id: str
        """

        self._id = id

    @property
    def type(self) -> str:
        """Gets the type of this RunStepDeltaStepDetailsToolCallsFunctionObject.

        The type of tool call. This is always going to be `function` for this type of tool call.  # noqa: E501

        :return: The type of this RunStepDeltaStepDetailsToolCallsFunctionObject.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type: str):
        """Sets the type of this RunStepDeltaStepDetailsToolCallsFunctionObject.

        The type of tool call. This is always going to be `function` for this type of tool call.  # noqa: E501

        :param type: The type of this RunStepDeltaStepDetailsToolCallsFunctionObject.
        :type type: str
        """
        allowed_values = ["function"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def function(self) -> RunStepDeltaStepDetailsToolCallsFunctionObjectFunction:
        """Gets the function of this RunStepDeltaStepDetailsToolCallsFunctionObject.


        :return: The function of this RunStepDeltaStepDetailsToolCallsFunctionObject.
        :rtype: RunStepDeltaStepDetailsToolCallsFunctionObjectFunction
        """
        return self._function

    @function.setter
    def function(self, function: RunStepDeltaStepDetailsToolCallsFunctionObjectFunction):
        """Sets the function of this RunStepDeltaStepDetailsToolCallsFunctionObject.


        :param function: The function of this RunStepDeltaStepDetailsToolCallsFunctionObject.
        :type function: RunStepDeltaStepDetailsToolCallsFunctionObjectFunction
        """

        self._function = function
