from datetime import date, datetime  # noqa: F401
from typing import Dict, List  # noqa: F401

from timestep.api.openai.v1 import util
from timestep.api.openai.v1.models.base_model import Model
from timestep.api.openai.v1.models.run_tool_call_object_function import \
    RunToolCallObjectFunction  # noqa: E501


class RunToolCallObject(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, id=None, type=None, function=None):  # noqa: E501
        """RunToolCallObject - a model defined in OpenAPI

        :param id: The id of this RunToolCallObject.  # noqa: E501
        :type id: str
        :param type: The type of this RunToolCallObject.  # noqa: E501
        :type type: str
        :param function: The function of this RunToolCallObject.  # noqa: E501
        :type function: RunToolCallObjectFunction
        """
        self.openapi_types = {
            'id': str,
            'type': str,
            'function': RunToolCallObjectFunction
        }

        self.attribute_map = {
            'id': 'id',
            'type': 'type',
            'function': 'function'
        }

        self._id = id
        self._type = type
        self._function = function

    @classmethod
    def from_dict(cls, dikt) -> 'RunToolCallObject':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The RunToolCallObject of this RunToolCallObject.  # noqa: E501
        :rtype: RunToolCallObject
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self) -> str:
        """Gets the id of this RunToolCallObject.

        The ID of the tool call. This ID must be referenced when you submit the tool outputs in using the [Submit tool outputs to run](/docs/api-reference/runs/submitToolOutputs) endpoint.  # noqa: E501

        :return: The id of this RunToolCallObject.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id: str):
        """Sets the id of this RunToolCallObject.

        The ID of the tool call. This ID must be referenced when you submit the tool outputs in using the [Submit tool outputs to run](/docs/api-reference/runs/submitToolOutputs) endpoint.  # noqa: E501

        :param id: The id of this RunToolCallObject.
        :type id: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def type(self) -> str:
        """Gets the type of this RunToolCallObject.

        The type of tool call the output is required for. For now, this is always `function`.  # noqa: E501

        :return: The type of this RunToolCallObject.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type: str):
        """Sets the type of this RunToolCallObject.

        The type of tool call the output is required for. For now, this is always `function`.  # noqa: E501

        :param type: The type of this RunToolCallObject.
        :type type: str
        """
        allowed_values = ["function"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def function(self) -> RunToolCallObjectFunction:
        """Gets the function of this RunToolCallObject.


        :return: The function of this RunToolCallObject.
        :rtype: RunToolCallObjectFunction
        """
        return self._function

    @function.setter
    def function(self, function: RunToolCallObjectFunction):
        """Sets the function of this RunToolCallObject.


        :param function: The function of this RunToolCallObject.
        :type function: RunToolCallObjectFunction
        """
        if function is None:
            raise ValueError("Invalid value for `function`, must not be `None`")  # noqa: E501

        self._function = function
